searchNodes=[{"doc":"Generates controller, views, and context for an HTML resource in Temple.mix temple.gen.html Accounts User users name:string age:integerThe first argument is the context module followed by the schema module and its plural name (used as the schema table name).The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource.Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User).The schema is responsible for mapping the database fields into an Elixir struct.Overall, this generator will add the following files to lib/:a context module in lib/app/accounts.ex for the accounts APIa schema in lib/app/accounts/user.ex, with an users tablea view in lib/app_web/views/user_view.exa controller in lib/app_web/controllers/user_controller.exdefault CRUD templates in lib/app_web/templates/userA migration file for the repository and test files for the context and controller features will also be generated.The location of the web files (controllers, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration:config :my_app_web, :generators, context_app: :my_appAlternatively, the --context-app option may be supplied to the generator:mix phx.gen.html Sales User users --context-app warehouseWeb namespaceBy default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example:mix phx.gen.html.temple Sales User users --web SalesWhich would generate a lib/app_web/controllers/sales/user_controller.ex and lib/app_web/views/sales/user_view.ex.Generating without a schema or context fileIn some cases, you may wish to bootstrap HTML templates, controllers, and controller tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control.tableBy default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example:mix phx.gen.html.temple Accounts User users --table cms_usersbinary_idGenerated migration can use binary_id for schema's primary key and its references with option --binary-id.Default optionsThis generator uses default options provided in the :generators configuration of your application. These are the defaults:config :your_app, :generators, migration: true, binary_id: false, sample_binary_id: &quot;11111111-1111-1111-1111-111111111111&quot;You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration.Read the documentation for phx.gen.schema for more information on attributes.","ref":"Mix.Tasks.Temple.Gen.Html.html","title":"Mix.Tasks.Temple.Gen.Html","type":"task"},{"doc":"","ref":"Mix.Tasks.Temple.Gen.Html.html#inputs/1","title":"Mix.Tasks.Temple.Gen.Html.inputs/1","type":"function"},{"doc":"Generates a Phoenix layout file in Temple.mix temple.gen.layout","ref":"Mix.Tasks.Temple.Gen.Layout.html","title":"Mix.Tasks.Temple.Gen.Layout","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Temple.Gen.Layout.html#run/1","title":"Mix.Tasks.Temple.Gen.Layout.run/1","type":"function"},{"doc":"Generates LiveView, templates, and context for a resource.mix temple.gen.live Accounts User users name:string age:integerThe first argument is the context module followed by the schema module and its plural name (used as the schema table name).The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource.When this command is run for the first time, a ModalComponent and LiveHelpers module will be created, along with the resource level LiveViews and components, including an IndexLive, ShowLive, FormComponent for the new resource.Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User).The schema is responsible for mapping the database fields into an Elixir struct. It is followed by an optional list of attributes, with their respective names and types. See mix phx.gen.schema for more information on attributes.Overall, this generator will add the following files to lib/:a context module in lib/app/accounts.ex for the accounts APIa schema in lib/app/accounts/user.ex, with an users tablea view in lib/app_web/views/user_view.exa LiveView in lib/app_web/live/user_live/show_live.exa LiveView in lib/app_web/live/user_live/index_live.exa LiveComponent in lib/app_web/live/user_live/form_component.exa LiveComponent in lib/app_web/live/modal_component.exa helpers modules in lib/app_web/live/live_helpers.exThe context appA migration file for the repository and test files for the context and controller features will also be generated.The location of the web files (LiveView's, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration:config :my_app_web, :generators, context_app: :my_appAlternatively, the --context-app option may be supplied to the generator:mix temple.gen.live Sales User users --context-app warehouseWeb namespaceBy default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example:mix temple.gen.live Sales User users --web SalesWhich would generate a LiveViews inside lib/app_web/live/sales/user_live/ and a view at lib/app_web/views/sales/user_view.ex.Customising the context, schema, tables and migrationsIn some cases, you may wish to bootstrap HTML templates, LiveViews, and tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control.You can also change the table name or configure the migrations to use binary ids for primary keys, see mix phx.gen.schema for more information.","ref":"Mix.Tasks.Temple.Gen.Live.html","title":"Mix.Tasks.Temple.Gen.Live","type":"task"},{"doc":"Temple syntax is available inside the temple, and is compiled into EEx at build time.Usagetemple do # You can define attributes by passing a keyword list to the element, the values can be literals or variables. class = &quot;text-blue&quot; id = &quot;jumbotron&quot; div class: class, id: id do # Text nodes can be emitted as string literals or variables. &quot;Bob&quot; id end # if and unless expressions can be used to conditionally render content if 5 &gt; 0 do p do &quot;Greater than 0!&quot; end end unless 5 &gt; 0 do p do &quot;Less than 0!&quot; end end # You can loop over items using for comprehensions for x &lt;- 0..5 do div do x end end # You can use multiline anonymous functions, like if you&#39;re building a form in Phoenix form_for @changeset, Routes.user_path(@conn, :create), fn f -&gt; &quot;Name: &quot; text_input f, :name end # You can explicitly emit a tag by prefixing with the Temple module Temple.div do &quot;Foo&quot; end # You can also pass children as a do key instead of a block div do: &quot;Alice&quot;, class: &quot;text-yellow&quot; endReserved keywordsYou can pass a keyword list to an element as element attributes, but there is currently a reserved keyword.CompactPassing compact: true will not emit a new line between the opening tag, the content, and the closing tag. This is useful if you are trying to use the :empty psuedo selector.temple do p compact: true do &quot;Foo&quot; end p do &quot;Bar&quot; end endwould evaluate to&lt;p&gt;Foo&lt;/p&gt; &lt;p&gt; Bar &lt;/p&gt;ConfigurationAliasesYou can add an alias for an element if there is a namespace collision with a function. If you are using Phoenix.HTML, there will be namespace collisions with the &lt;link&gt; and &lt;label&gt; elements.config :temple, :aliases, label: :_label, link: :_link temple do _label do &quot;Email&quot; end _link href: &quot;/css/site.css&quot; endThis will result in:&lt;label&gt; Email &lt;/label&gt; &lt;link href=&quot;/css/site.css&quot;&gt;","ref":"Temple.html","title":"Temple","type":"module"},{"doc":"Compiles temple markup into a quoted expression using the given EEx Engine.Usagerequire Temple Temple.compile Phoenix.HTML.Engine do div class: @class do &quot;Hello, world!&quot; end end # Returns the same output that Phoenix templates output into the `render/1` function of their view modules.","ref":"Temple.html#compile/2","title":"Temple.compile/2","type":"macro"},{"doc":"Context for temple markup.Returns an EEx string.Usageimport Temple temple do div class: @class do &quot;Hello, world!&quot; end end # &lt;div class=&quot;&lt;%= @class %&gt;&quot;&gt; # Hello, world! # &lt;/div&gt;","ref":"Temple.html#temple/1","title":"Temple.temple/1","type":"macro"},{"doc":"API for defining components.Component modules are basically normal Phoenix View modules. The contents of the render macro are compiled into a render/2 function. This means that you can define functions in your component module and use them in your component markup.Since component modules are view modules, the assigns you pass to the component are accessible via the @ macro and the assigns variable.Usagedefmodule MyAppWeb.Components.Flash do use Temple.Component def border_class(:info), do: &quot;border-blue-500&quot; def border_class(:warning), do: &quot;border-yellow-500&quot; def border_class(:error), do: &quot;border-red-500&quot; def border_class(:success), do: &quot;border-green-500&quot; render do div class: &quot;border rounded p-2 \#{assigns[:class]} \#{border_class(@message_type)}&quot; do @inner_content end end endComponents are used by calling the c keyword, followed by the component module and any assigns you need to pass to the template.c is a compile time keyword, not a function or a macro, so you won't see it in the generated documention.c MyAppWeb.Components.Flash, class: &quot;font-bold&quot;, message_type: :info do ul do for info &lt;- infos do li class: &quot;p-4&quot; do info.message end end end endSince components are just modules, if you alias your module, you can use them more ergonomically.alias MyAppWeb.Components.Flex c Flex, class: &quot;justify-between items center&quot; do for item &lt;- items do div class: &quot;p-4&quot; do item.name end end end","ref":"Temple.Component.html","title":"Temple.Component","type":"module"},{"doc":"Defines a component module.This macro makes it easy to define components without creating a separate file. It literally inlines a component module.Since it defines a module inside of the current module, local function calls from the outer module won't be available. For convenience, the outer module is aliased for you, so you can call remote functions with a shorter module name.Usagedef MyAppWeb.SomeView do use MyAppWeb.SomeView, :view import Temple.Component, only: [defcomp: 2] # define a function in outer module def foobar(), do: &quot;foobar&quot; # define a component defcomp Button do button id: SomeView.foobar(), # `MyAppWeb.SomeView` is aliased for you. class: &quot;text-sm px-3 py-2 rounded \#{assigns[:extra_classes]}&quot;, type: &quot;submit&quot; do @inner_content end end end # use the component in a SomeView template. Or else, you must alias `MyAppWeb.SomeView.Button` c Button, extra_classes: &quot;border-2 border-red-500&quot; do &quot;Submit!&quot; end","ref":"Temple.Component.html#defcomp/2","title":"Temple.Component.defcomp/2","type":"macro"},{"doc":"Defines a component template.Usagedefmodule MyAppWeb.Components.Flash do use Temple.Component def border_class(:info), do: &quot;border-blue-500&quot; def border_class(:warning), do: &quot;border-yellow-500&quot; def border_class(:error), do: &quot;border-red-500&quot; def border_class(:success), do: &quot;border-green-500&quot; render do div class: &quot;border rounded p-2 \#{assigns[:class]} \#{border_class(@message_type)}&quot; do @inner_content end end end","ref":"Temple.Component.html#render/1","title":"Temple.Component.render/1","type":"macro"},{"doc":"The Temple HTML engine makes it possible to use Temple with Phoenix controllers.To get started, you will configure Phoenix to use this module for .exs files.# config.exs config :phoenix, :template_engines, # this will work for files named like `index.html.exs` exs: Temple.Engine # config/dev.exs config :your_app, YourAppWeb.Endpoint, live_reload: [ patterns: [ ~r&quot;lib/myapp_web/(live|views)/.*(ex|exs|lexs)$&quot;, ~r&quot;lib/myapp_web/templates/.*(eex|exs|lexs)$&quot; ] ] # my_app/ # lib/ # my_app/ # my_app_web/ # templates/ # posts/ # show.html.exsNow you can get started by writing exs files in the templates directory and they will be compiled as you would expect.","ref":"Temple.Engine.html","title":"Temple.Engine","type":"module"},{"doc":"Callback implementation for Phoenix.Template.Engine.compile/2.","ref":"Temple.Engine.html#compile/2","title":"Temple.Engine.compile/2","type":"function"},{"doc":"The Temple LiveView engine makes it possible to use Temple with Phoenix LiveView.To get started, you will configure Phoenix to use this module for .lexs files.# config.exs config :phoenix, :template_engines, # this will work for files named like `index.html.lexs` # you can enable Elixir syntax highlighting in your editor for this extension lexs: Temple.LiveViewEngine # config/dev.exs config :your_app, YourAppWeb.Endpoint, live_reload: [ patterns: [ ~r&quot;lib/myapp_web/(live|views)/.*(ex|exs|lexs)$&quot;, ~r&quot;lib/myapp_web/templates/.*(eex|exs|lexs)$&quot; ] ] # my_app/ # lib/ # my_app/ # my_app_web/ # live/ # posts_live/ # show.ex # show.html.lexsNow you can get started by writing lexs files co-located with your live views and they will be compiled as you would expect.","ref":"Temple.LiveViewEngine.html","title":"Temple.LiveViewEngine","type":"module"},{"doc":"Callback implementation for Phoenix.Template.Engine.compile/2.","ref":"Temple.LiveViewEngine.html#compile/2","title":"Temple.LiveViewEngine.compile/2","type":"function"},{"doc":"You are looking at the README for the master branch. The README for the latest stable release is located here.Temple is a DSL for writing HTML and EEx using Elixir.You're probably here because you want to use Temple to write Phoenix templates, which is why Temple includes a Phoenix template engine.","ref":"readme.html","title":"","type":"extras"},{"doc":"Add temple to your list of dependencies in mix.exs:def deps do [ {:temple, &quot;~&gt; 0.6.0-rc.0&quot;}, {:phoenix, &quot;&gt;= 1.5.0&quot;} # requires at least Phoenix v1.5.0 ] endordef deps do [{:temple, github: &quot;mhanberg/temple&quot;}] end","ref":"readme.html#installation","title":" - Installation","type":"extras"},{"doc":"Using Temple is as simple as using the DSL inside of an temple/1 block. This returns an EEx string at compile time.See the documentation for more details.use Temple temple do h2 do: &quot;todos&quot; ul class: &quot;list&quot; do for item &lt;- @items do li class: &quot;item&quot; do div class: &quot;checkbox&quot; do div class: &quot;bullet hidden&quot; end div do: item end end end script do: &quot;&quot;&quot; function toggleCheck({currentTarget}) { currentTarget.children[0].children[0].classList.toggle(&quot;hidden&quot;); } let items = document.querySelectorAll(&quot;li&quot;); Array.from(items).forEach(checkbox =&gt; checkbox.addEventListener(&quot;click&quot;, toggleCheck)); &quot;&quot;&quot; endComponentsTemple components are mostly a little syntax sugar over Phoenix's render/3 and render_layout/4 functions.For example, if I were to define a Flex component, I would create the following module.defmodule MyAppWeb.Components.Flex do use Temple.Component render do div class: &quot;flex #\\{@class}&quot; do @inner_content end end endAnd we could use the component like soalias MyAppWeb.Components.Flex c Flex, class: &quot;justify-between items-center&quot;, id: &quot;arnold&quot; do div do: &quot;Hi&quot; div do: &quot;I&#39;m&quot; div do: &quot;Arnold&quot; div do: &quot;Schwarzenegger&quot; endPhoenix templatesAdd the template engine to your Phoenix configuration.# config.exs config :phoenix, :template_engines, exs: Temple.Engine # or for LiveView support # this will work for files named like `index.html.lexs` # you can enable Elixir syntax highlighting in your editor lexs: Temple.LiveViewEngine # config/dev.exs config :your_app, YourAppWeb.Endpoint, live_reload: [ patterns: [ ~r&quot;lib/myapp_web/(live|views)/.*(ex|exs|lexs)$&quot;, ~r&quot;lib/myapp_web/templates/.*(eex|exs|lexs)$&quot; ] ]# app.html.exs html lang: &quot;en&quot; do head do meta charset: &quot;utf-8&quot; meta http_equiv: &quot;X-UA-Compatible&quot;, content: &quot;IE=edge&quot; meta name: &quot;viewport&quot;, content: &quot;width=device-width, initial-scale=1.0&quot; title do: &quot;YourApp · Phoenix Framework&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do header do section class: &quot;container&quot; do nav role: &quot;navigation&quot; do ul do li do: a(&quot;Get Started&quot;, href: &quot;https://hexdocs.pm/phoenix/overview.html&quot;) end end a href: &quot;http://phoenixframework.org/&quot;, class: &quot;phx-logo&quot; do img src: Routes.static_path(@conn, &quot;/images/phoenix.png&quot;), alt: &quot;Phoenix Framework Logo&quot; end end end main role: &quot;main&quot;, class: &quot;container&quot; do p class: &quot;alert alert-info&quot;, role: &quot;alert&quot;, compact: true, do: get_flash(@conn, :info) p class: &quot;alert alert-danger&quot;, role: &quot;alert&quot;, compact: true, do: get_flash(@conn, :error) render @view_module, @view_template, assigns end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end endTaskstemple.gen.layoutGenerates the app layout.temple.gen.htmlGenerates the templates for a resource.FormatterTo include Temple's formatter configuration, add :temple to your .formatter.exs.[ import_deps: [:temple], inputs: [&quot;*.{ex,exs}&quot;, &quot;priv/*/seeds.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs,lexs}&quot;], ]","ref":"readme.html#usage","title":" - Usage","type":"extras"}]